import { Prisma } from '@prisma/client';
import { CacheOptions, CacheQueryArgs } from './types';
export declare function cache(opts: CacheOptions): (client: any) => {
    $extends: {
        extArgs: {
            result: {};
            model: {
                $allModels: {
                    findUnique: () => <T, A extends Prisma.Args<T, "findUnique"> & Partial<CacheQueryArgs>>(this: T, args?: Prisma.Exact<A, Prisma.Args<T, "findUnique"> & Partial<CacheQueryArgs>> | undefined) => Promise<Prisma.Result<T, A, "findUnique">>;
                    findUniqueOrThrow: () => <T_1, A_1 extends Prisma.Args<T_1, "findUnique"> & Partial<CacheQueryArgs>>(this: T_1, args?: Prisma.Exact<A_1, Prisma.Args<T_1, "findUniqueOrThrow"> & Partial<CacheQueryArgs>> | undefined) => Promise<Prisma.Result<T_1, A_1, "findUniqueOrThrow">>;
                    findFirst: () => <T_2, A_2 extends Prisma.Args<T_2, "findFirst"> & Partial<CacheQueryArgs>>(this: T_2, args?: Prisma.Exact<A_2, Prisma.Args<T_2, "findFirst"> & Partial<CacheQueryArgs>> | undefined) => Promise<Prisma.Result<T_2, A_2, "findFirst">>;
                    findFirstOrThrow: () => <T_3, A_3 extends Prisma.Args<T_3, "findFirst"> & Partial<CacheQueryArgs>>(this: T_3, args?: Prisma.Exact<A_3, Prisma.Args<T_3, "findFirstOrThrow"> & Partial<CacheQueryArgs>> | undefined) => Promise<Prisma.Result<T_3, A_3, "findFirstOrThrow">>;
                    findMany: () => <T_4, A_4 extends Prisma.Args<T_4, "findMany"> & Partial<CacheQueryArgs>>(this: T_4, args?: Prisma.Exact<A_4, Prisma.Args<T_4, "findMany"> & Partial<CacheQueryArgs>> | undefined) => Promise<Prisma.Result<T_4, A_4, "findMany">>;
                    count: () => <T_5, A_5 extends Prisma.Args<T_5, "count"> & Partial<CacheQueryArgs>>(this: T_5, args?: Prisma.Exact<A_5, Prisma.Args<T_5, "count"> & Partial<CacheQueryArgs>> | undefined) => Promise<Prisma.Result<T_5, A_5, "count">>;
                    aggregate: () => <T_6, A_6 extends Prisma.Args<T_6, "aggregate"> & Partial<CacheQueryArgs>>(this: T_6, args?: Prisma.Exact<A_6, Prisma.Args<T_6, "aggregate"> & Partial<CacheQueryArgs>> | undefined) => Promise<Prisma.Result<T_6, A_6, "aggregate">>;
                    groupBy: () => <T_7, A_7 extends Prisma.Args<T_7, "groupBy"> & Partial<CacheQueryArgs>>(this: T_7, args?: Prisma.Exact<A_7, Prisma.Args<T_7, "groupBy"> & Partial<CacheQueryArgs>> | undefined) => Promise<Prisma.Result<T_7, A_7, "groupBy">>;
                    clearCache: () => () => Promise<void>;
                };
                planet: {
                    findUnique: () => <T, A extends Prisma.Args<T, "findUnique"> & Partial<CacheQueryArgs>>(this: T, args?: Prisma.Exact<A, Prisma.Args<T, "findUnique"> & Partial<CacheQueryArgs>> | undefined) => Promise<Prisma.Result<T, A, "findUnique">>;
                    findUniqueOrThrow: () => <T_1, A_1 extends Prisma.Args<T_1, "findUnique"> & Partial<CacheQueryArgs>>(this: T_1, args?: Prisma.Exact<A_1, Prisma.Args<T_1, "findUniqueOrThrow"> & Partial<CacheQueryArgs>> | undefined) => Promise<Prisma.Result<T_1, A_1, "findUniqueOrThrow">>;
                    findFirst: () => <T_2, A_2 extends Prisma.Args<T_2, "findFirst"> & Partial<CacheQueryArgs>>(this: T_2, args?: Prisma.Exact<A_2, Prisma.Args<T_2, "findFirst"> & Partial<CacheQueryArgs>> | undefined) => Promise<Prisma.Result<T_2, A_2, "findFirst">>;
                    findFirstOrThrow: () => <T_3, A_3 extends Prisma.Args<T_3, "findFirst"> & Partial<CacheQueryArgs>>(this: T_3, args?: Prisma.Exact<A_3, Prisma.Args<T_3, "findFirstOrThrow"> & Partial<CacheQueryArgs>> | undefined) => Promise<Prisma.Result<T_3, A_3, "findFirstOrThrow">>;
                    findMany: () => <T_4, A_4 extends Prisma.Args<T_4, "findMany"> & Partial<CacheQueryArgs>>(this: T_4, args?: Prisma.Exact<A_4, Prisma.Args<T_4, "findMany"> & Partial<CacheQueryArgs>> | undefined) => Promise<Prisma.Result<T_4, A_4, "findMany">>;
                    count: () => <T_5, A_5 extends Prisma.Args<T_5, "count"> & Partial<CacheQueryArgs>>(this: T_5, args?: Prisma.Exact<A_5, Prisma.Args<T_5, "count"> & Partial<CacheQueryArgs>> | undefined) => Promise<Prisma.Result<T_5, A_5, "count">>;
                    aggregate: () => <T_6, A_6 extends Prisma.Args<T_6, "aggregate"> & Partial<CacheQueryArgs>>(this: T_6, args?: Prisma.Exact<A_6, Prisma.Args<T_6, "aggregate"> & Partial<CacheQueryArgs>> | undefined) => Promise<Prisma.Result<T_6, A_6, "aggregate">>;
                    groupBy: () => <T_7, A_7 extends Prisma.Args<T_7, "groupBy"> & Partial<CacheQueryArgs>>(this: T_7, args?: Prisma.Exact<A_7, Prisma.Args<T_7, "groupBy"> & Partial<CacheQueryArgs>> | undefined) => Promise<Prisma.Result<T_7, A_7, "groupBy">>;
                    clearCache: () => () => Promise<void>;
                };
            };
            query: {};
            client: {
                clearCache: () => () => Promise<void>;
            };
        };
    };
};
export * from './types';
export * from './storage';
